function p = IFS(trans,shape,n)
% IFS(trans,shape,n)
%
% function returns points generated by IFS
%
% trans - list of affine transformations
% shape - starting shape
% n - number of iterations
%
%
% example:
% n = 10;
% trans = {[0.4194 0.3629 -0.0000; 0.0376 0.3306 0.0000; 0 0 1.0000],...
%          [0.5645 -0.2903 0; 0.0699 0.1855 0.0000; 0.8500 0.8250 1.0000]};
% shape = [0 0 1; 1 0 1; 0.5 1 1];
% p = IFS(trans,shape,n);

temp = shape;
[iw,ik] = size(temp);
tr = size(trans,2);
len = length(trans);

temp1 = zeros(iw,ik*len^n);
w = 1;
for i = 1:n
    k = 1;
    for j = 1:tr
        for m = 1:w
            temp1(:,1+(k-1)*ik:ik+(k-1)*ik) = temp(:,1+(m-1)*ik:ik+(m-1)*ik) * trans{j};
            k = k + 1;
        end
    end
    w = w * len;
    temp = temp1(:,1:ik*w);
end

p = temp;